from django.contrib.auth.backends import ModelBackend
from .models import ClubRepresentative

class ClubRepresentativeBackend(ModelBackend):
    def authenticate(self, request, **kwargs):
        username = kwargs.get('username')
        password = kwargs.get('password')
        if not username or not password:
            return None
        try:
            club_rep = ClubRepresentative.objects.get(representative_id=username)
        except ClubRepresentative.DoesNotExist:
            return None
        if club_rep.check_password(password):
            return club_rep
        return None